package com.eactive.eai.batch.job.jobItem.kftc;

import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.util.HashMap;
import java.util.Properties;

import com.eactive.eai.batch.common.CommonKeys;
import com.eactive.eai.batch.common.FileUtil;
import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobHandle.JobProcessData;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;
import com.eactive.eai.batch.running.BatchOpenFileManager;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_KFTCB_0320 extends DefaultTelegram implements TelegramService
{

	private BufferedInputStream bis;
    private int BLOCK_NO;
    private int SEQUENCE_NO;
    private int REAL_BYTE;         // 실 data byte수
    private int SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이

    private Properties telegramInfo;
    private byte[] fileData;

    /**
     * 생성자
     */
    public SEND_KFTCB_0320() {
        //DATA송신
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {
            boolean result = setBlockAndSeqNO();
            if (!result) {
                return false;
            }
            result = calculateSendLength();
            if (!result) return false;

            //전송길이
            compileField(1, "" + SEND_LENGTH, this.al_FieldProps[1]);

            //업무구분코드 - 센터 및 은행에서 업무구분을 위하여 SET
            compileField(2, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[2]);
            //전문종별코드. 전문의 기능을 나타냄.
            compileField(4, this.getFldTelegramType(), this.al_FieldProps[4]);
            //거래구분코드 "R"-센터 수신 업무, "S"-센터 송신업무
            //compileField(5, this.getFldTrClass(), this.al_FieldProps[5]);
            //기관별로 송수신시 사용되는 거래구분코드가 상이하여 기관별 속성값에서 참조하도록 함.
            String procType = batchDoc.getBatchMsg().getHeader().getProcessType();
            if ( procType.equalsIgnoreCase(CommonKeys.PROCESS_REQUEST_SEND) ||
                 procType.equalsIgnoreCase(CommonKeys.PROCESS_RESPONSE_SEND)) {
                compileField(5, telegramInfo.getProperty(TelegramKeys.TRAN_GBN_SEND), this.al_FieldProps[5]);
            }else{
                compileField(5, telegramInfo.getProperty(TelegramKeys.TRAN_GBN_RECV), this.al_FieldProps[5]);
            }
            //송수신 FLAG "C"-센터에서 전문을 발생할 시, "B"-은행에서 전문을 발생할 시
            if ( procType.equalsIgnoreCase(CommonKeys.PROCESS_REQUEST_SEND) ||
                 procType.equalsIgnoreCase(CommonKeys.PROCESS_RESPONSE_SEND)) {
                compileField(6, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_SEND), this.al_FieldProps[6]);
            }else{
                compileField(6, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_RECV), this.al_FieldProps[6]);
            }
            //화일명
        	String fileName = batchDoc.getBatchMsg().getHeader().getFileName();
        	if ( fileName.indexOf("_") > -1 ){
        		fileName = fileName.substring(0, fileName.indexOf("_"));
        	}
            compileField(7, fileName , this.al_FieldProps[7]);
            //응답코드
            compileField(8, this.getSendResponseCode(), this.al_FieldProps[8]);
            //BLOCK-NO
            compileField(9, ""+BLOCK_NO, this.al_FieldProps[9]);
            //SEQUENCE-NO
            compileField(10, ""+SEQUENCE_NO, this.al_FieldProps[10]);
            //실 DATA BYTE 수
            compileField(11, ""+REAL_BYTE, this.al_FieldProps[11]);

            //<< 전문 완성
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    public int getInformalFieldSendData(int idx, byte[] data) {
        int fldLen = getCalculatedLength(idx);
        try {
            if (idx >= this.getFieldCount() ) {
            	logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (data.length < fldLen) {
            	logger.debug("{}  getInformalFieldSendData> InformalFieldSendData size is bigger than buffer size", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI014";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            switch (idx) {
            case 0:
                // TR 코드
                System.arraycopy((telegramInfo.getProperty(TelegramKeys.TRANSACTION_CODE) + "         ").getBytes(), 0, data, 0, fldLen );

                break;
            case 3:
                // 기관코드
                System.arraycopy((telegramInfo.getProperty(TelegramKeys.BANK_CODE) + "          ").getBytes(), 0, data, 0, fldLen );

                break;
            case 12:
                ByteArrayInputStream bin = new ByteArrayInputStream(fileData);
                bin.read(data, 0, REAL_BYTE);
                // 20060419 add by khs for 전송상태 확인
                long lnCurSize = batchDoc.getBatchMsg().getBody().getCurFileSize() + REAL_BYTE;
                batchDoc.getBatchMsg().getBody().setCurFileSize(lnCurSize);
            default:
                break;
            }

            // 로깅을 위해
            byte[] fieldData = new byte[fldLen];
            System.arraycopy(data, 0, fieldData, 0, fldLen);
            this.al_Field.set( idx, fieldData);
            return fldLen;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return -1;
        }
    }

    public boolean doPostExecute() {
        try {
            if (!super.doPostExecute()) return false;

            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<9; i++) { //CMS전문의 헤더는 응답코드까지 임.
                byte[] barr = (byte[])this.al_Field.get(i);
                if ( barr[0] != '\0') {
                    baout.write((byte[])this.al_Field.get(i));
                }
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=9; i< al_Field.size()-1; i++) {  //결번확인 필드는 비정형 필드로 바디 로그에서 제외
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;

        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            try {
				int sleepTime = Integer.parseInt(telegramInfo.getProperty(TelegramKeys.SLEEP_TIME));
				Thread.sleep(sleepTime); 
			} catch (Exception e) {}
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    /**
     * int getCalculatedLength(int idx)
     * --------------------------------------------------------------------------------------
     * 전달된 인덱스 idx는 비정형 필드여야 한다. 즉 필드의 길이값이 FILE_NO_LENGTH("XX") 이어야 한다.
     * 해당 비정형 필드에 대해 실질적인 전문길이를 동적으로 계산해 낸다.
     */
    public int getCalculatedLength(int idx) {

        if (idx >= this.getFieldCount()) {
        	logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI011";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        if (!this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        int fieldLen = -1;
        String propKey = "";
        switch (idx) {

        case 0:
            propKey = TelegramKeys.TRCD_LEN;
            break;

        case 3:
            propKey = TelegramKeys.ORGN_CD_LEN;
            break;
        case 12:
            return REAL_BYTE;
        default:
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }

        try {
            fieldLen = Integer.parseInt( telegramInfo.getProperty(propKey) );

        } catch (Exception e) {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = propKey;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }

        return fieldLen;
    }

    private boolean createFile ()
    {

        bis = BatchOpenFileManager.getInstance().getBis(batchDoc.getBatchMsg().getHeader().getUUID());
        if( bis != null ) return true;
        try {
            String fileDir = batchDoc.getBatchMsg().getHeader().getFilePath();
            String fileNm  = batchDoc.getBatchMsg().getHeader().getRenamedFileName();

            if (fileDir.charAt(fileDir.length()-1) != File.separatorChar) {
                fileDir = fileDir + File.separator;
            }

            String fileName = fileDir + fileNm;

            File file = new File(fileName);
            if (!file.exists()) // 파일이 없으면 리턴 False
            {
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = fileName;
                String errCode = "BECEAIFJI022";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                throw new Exception(" the File["+fileName+"] does not exist!!!");
            }
            bis = new BufferedInputStream ( new FileInputStream(file) );
            BatchOpenFileManager.getInstance().addBis(batchDoc.getBatchMsg().getHeader().getUUID() , fileName, bis);
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI028";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }

    }

    private boolean setBlockAndSeqNO ()
    {
        try {
            if (!createFile()) {
            	logger.error("{}  file open failed", logHeader);
                return false;
            }

            int block_size = this.batchDoc.getBatchMsg().getHeader().getBlockSize();
            int block_no = this.batchDoc.getBatchMsg().getBody().getBlockNum();
            int seq_no = this.batchDoc.getBatchMsg().getBody().getSeqNum();

            if (block_no == 0 && seq_no == 0) { //첫 0320 전송이면
                this.BLOCK_NO = 1;
                this.SEQUENCE_NO = 1;
                this.setConditionTxt("");

            } else {
                if (seq_no == block_size) { //한 블럭 송신 후 결번확인(0300) 이후 데이터 전송
                    this.BLOCK_NO = block_no+1;
                    this.SEQUENCE_NO = 1;
                    this.setConditionTxt("");

                } else if (seq_no >= block_size-1) {    //블럭 크기에 도달하면 BLOCKEND 하여 다음 0620전문으로 넘어가게 함
                    this.BLOCK_NO = block_no;
                    this.SEQUENCE_NO = seq_no+1;
                    this.setConditionTxt(TelegramKeys.BLOCKEND);
                } else {            //한 블럭내에 데이터 전송 반복이면
                    this.BLOCK_NO = block_no;
                    this.SEQUENCE_NO = seq_no+1;
                    this.setConditionTxt("");
                }

            }
            // 한번에 블러킹 할 건수
            int seqCnt = ( batchDoc.getBatchMsg().getHeader().getSequenceSize() / batchDoc.getBatchMsg().getHeader().getRecLen() );
            // 남은 바이트 수
            long remainSize = batchDoc.getBatchMsg().getHeader().getFileSize() - batchDoc.getBatchMsg().getBody().getCurFileSize();
            // 남은 건수
            long remainCnt = remainSize / batchDoc.getBatchMsg().getHeader().getRecLen();

            boolean isLastSeq = false;
            if ( seqCnt < remainCnt ){
                REAL_BYTE = seqCnt * batchDoc.getBatchMsg().getHeader().getRecLen();
            }else{
                REAL_BYTE = (int)remainCnt * batchDoc.getBatchMsg().getHeader().getRecLen();
                this.setConditionTxt(TelegramKeys.BLOCKEND);
                isLastSeq = true;
            }
            int readCnt = REAL_BYTE / batchDoc.getBatchMsg().getHeader().getRecLen();

            int appendLen = 0;
            try {
            	appendLen = Integer.parseInt(getJobInfo().getProperty(TelegramKeys.APPEND_LL_LEN));
			} catch (Exception e) {}

            boolean isBinary = false;
            try {
            	if ( "Y".equals(getJobInfo().getProperty(TelegramKeys.SKIP_LF)) )
            		isBinary = true;
			} catch (Exception e) {}

            fileData = new byte[REAL_BYTE];
            if ( isBinary ){
            	bis.read(fileData, 0, REAL_BYTE );
            }else{
                for ( int inx = 0 ; inx < readCnt ; inx++){
                    byte[] fileLine = FileUtil.readLine(bis);
                    if ( fileLine == null ){
                        String[] msgArgs = new String[1];
                        msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                        String errCode = "BECEAIFJI029";
                        Exception e = new Exception("체크파일에 명시된 건수와 DATA 파일의 건수가 맞지 않습니다. \n"+
                        		                    "확인 바랍니다.");  
                        String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
                        this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                        logger.error( e.getMessage(), e);
                    	return false;
                    }
                    if ( fileLine.length + appendLen < batchDoc.getBatchMsg().getHeader().getRecLen() ){
                        Exception e = new Exception("정의된 레코드 길이 보다 읽은 파일 레코드 길이가 작습니다. \n"+
                                                    "확인 바랍니다.\n" +
                                                    "정의된 길이 [" + batchDoc.getBatchMsg().getHeader().getRecLen() + "], " +
                                                    "파일에서 읽은 길이[" + fileLine.length + "]");
                        this.batchDoc.getBatchMsg().getBody().setErrorMsg(e.getMessage());
                        logger.error( e.getMessage(), e);
                        return false;
                    }
                    System.arraycopy( fileLine, 0, fileData, inx * batchDoc.getBatchMsg().getHeader().getRecLen(),
                    		          Math.min(batchDoc.getBatchMsg().getHeader().getRecLen(), fileLine.length));
                    if ( appendLen > 0 ){
                    	fileData[((inx+1) * batchDoc.getBatchMsg().getHeader().getRecLen())-1] = '\n';
                    }
                    if ( appendLen > 1 ){
                    	fileData[((inx+1) * batchDoc.getBatchMsg().getHeader().getRecLen())-2] = '\r';
                    }
                }
            }

            if ( isLastSeq ){
                bis.close();
                BatchOpenFileManager.getInstance().removeFile(batchDoc.getBatchMsg().getHeader().getUUID());
            }

            // 파일에서 읽은 DATA를 추후 결번 재전송을 위해 메모리에 저장해 둔다. 2008.06.19 - 정동한
            JobProcessData job = JobProcessData.getInstance();
            String uuid = this.batchDoc.getBatchMsg().getHeader().getUUID();
            HashMap<String, Object> hm = job.getBatchStageData(uuid);

            @SuppressWarnings("unchecked")
            HashMap<Integer, byte[]> block_data = (HashMap<Integer, byte[]>) hm.get(JobProcessData.PROCDATA_BLOCKDATA);
            if (block_data == null) {
                block_data = new HashMap<Integer, byte[]>();
            }
            block_data.put( new Integer(SEQUENCE_NO-1), fileData);
            hm.put(JobProcessData.PROCDATA_BLOCKDATA, block_data);
            // 2008.06.19 - 정동한

            this.batchDoc.getBatchMsg().getBody().setBlockNum(BLOCK_NO);
            this.batchDoc.getBatchMsg().getBody().setSeqNum(SEQUENCE_NO);

            return true;
        } catch (Exception e ) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI029";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    private boolean calculateSendLength () {
        try {
            // XX인 경우 길이를 1로 계산하므로 i=3 인 경우 실제 기관 코드 사용 길이-1 만큼을 더 해 준다.
            for (int i=2; i< this.al_Field.size()-1; i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            SEND_LENGTH += ( getCalculatedLength(3) - 1 );
            SEND_LENGTH += REAL_BYTE;
            REAL_SEND_LENGTH = SEND_LENGTH + getCalculatedLength(0) + ((byte[]) this.al_Field.get(1)).length;

        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(4);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
        return super.getFieldValueString(5);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(8);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getOpCode();
    }
}